/* 
 * Koristimo korektno definisanu biblioteku kompleksnih brojeva. 
 * U zaglavlju complex.h nalazi se definicija komplesnog broja i popis deklaracija podrzanih funkcija
 * a u complex.c se nalaze njihove definicije.
 * 
 * Ovde pisemo i main() funkciju drugaciju od prethodnog zadatka. 
 * 
 * I dalje kompilacija programa se najjednostavnije postize naredbom
 * gcc -Wall -lm -o izvrsni complex.c main.c 
 * 
 * 
 * Kompilaciju možemo uraditi izvrsavanjem 3 naredbe iz terminala:
        gcc  -Wall  -c  -o complex.o complex.c
        gcc  -Wall  -c  -o main.o main.c
        gcc -lm  -o complex complex.o main.o
 * 
 * Ovaj postupak se moze automatizovati pisanjem datoteke Makefile
 u kojoj popišemo postupak kojim se od izvornih datoteka dobija željeni izvršni program, 
 a make alat će za nas izvrši naznačene komande. 
 
 Potom je samo potrebno je iz terminala izvrsiti naredbu make.
*/


#include <stdio.h>
/* Ukljucujemo zaglavlje neophodno za rad sa kompleksnim brojevima */
#include "complex.h"

/* Ovo zaglavlje ukljucujemo samo iz razloga da demostiramo problem koji nastaje kada se zaglavlje complex.h ne zakljucava */
#include "zaglavlje.h"

#include <stdio.h>
/* Ukljucujemo zaglavlje neophodno za rad sa kompleksnim brojevima */
#include "complex.h"

/* U main funkciji za uneti kompleksan broj ispisujemo njegov polarni oblik */
int main() {
   KompleksanBroj z;
   
   /* Ucitavamo kompleksan broj */
   ucitaj_kompleksan_broj(&z);
  
   ispisi_kompleksan_broj(z);
   
   printf("\n");
   
   printf("Polarni oblik kompleksnog broj je %.2f *  e^i * %f\n",moduo(z), argument(z));
  
   return 0;
}
